example/src/com/sun/webui/jsf/example/chooseruploader/ChooserUploaderBackingBean.java
/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright (c) 2007-2018 Oracle and/or its affiliates. All rights reserved.
 *
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common Development
 * and Distribution License("CDDL") (collectively, the "License").  You
 * may not use this file except in compliance with the License.  You can
 * obtain a copy of the License at
 * https://oss.oracle.com/licenses/CDDL+GPL-1.1
 * or LICENSE.txt.  See the License for the specific
 * language governing permissions and limitations under the License.
 *
 * When distributing the software, include this License Header Notice in each
 * file and include the License file at LICENSE.txt.
 *
 * GPL Classpath Exception:
 * Oracle designates this particular file as subject to the "Classpath"
 * exception as provided by Oracle in the GPL Version 2 section of the License
 * file that accompanied this code.
 *
 * Modifications:
 * If applicable, add the following below the License Header, with the fields
 * enclosed by brackets [] replaced by your own identifying information:
 * "Portions Copyright [year] [name of copyright owner]"
 *
 * Contributor(s):
 * If you wish your version of this file to be governed by only the CDDL or
 * only the GPL Version 2, indicate your decision by adding "[Contributor]
 * elects to include this software in this distribution under the [CDDL or GPL
 * Version 2] license."  If you don't indicate a single choice of license, a
 * recipient has the option to distribute your version of this file under
 * either the CDDL, the GPL Version 2 or to extend the choice of license to
 * its licensees as provided above.  However, if you add GPL Version 2 code
 * and therefore, elected the GPL Version 2 license, then the option applies
 * only if the new code is made subject to such option by the copyright
 * holder.
 */

package com.sun.webui.jsf.example.chooseruploader;

import com.sun.webui.jsf.model.UploadedFile;
import javax.faces.context.FacesContext;
import javax.faces.event.ActionEvent;
import javax.faces.application.FacesMessage;

import com.sun.webui.jsf.example.common.MessageUtil;
import com.sun.webui.jsf.example.index.IndexBackingBean;

import java.io.*;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * Backing Bean for Chooser Uploader example.
 */
public class ChooserUploaderBackingBean implements Serializable {
    
    // String constant.
    public static final String WINDOWS_OS = "WINDOW";
    
    // Holds value of property lookin.
    private File lookin = null;
    
    // Holds value of property fileChooserLookin.
    private File fileChooserLookin = null;
    
    // Holds value of property selected.
    private File selected = null;
    
    // Holds value of property uploadPath.
    private String uploadPath = null;
    
    // Holds value of property forwardName.
    private String forwardName = null;
    
    // Holds value of property uploadedFile.
    private UploadedFile uploadedFile;
    
    /** Creates a new instance of ChooserUploaderBackingBean */
    public ChooserUploaderBackingBean() {
        String osName = System.getProperty("os.name").toUpperCase();
        
            if (osName.startsWith(WINDOWS_OS)) {
                lookin = new File("c:\\\\windows");
            } else {
                lookin = new File("/usr");
            }
            fileChooserLookin = new File(lookin.toString());
    }
    
    /**
     * Getter for property uploadedFile.
     * @return Value of property uploadedFile.
     */
    public UploadedFile getUploadedFile() {
        
        return this.uploadedFile;
    }
    
    /**
     * Setter for property uploadedFile.
     * @param uploadedFile New value of property uploadedFile.
     */
    public void setUploadedFile(UploadedFile uploadedFile) {
        
        this.uploadedFile = uploadedFile;
    }
    
    /**
     *Getter for property lookin
     *@return Value of property lookin.
     */
    public File getLookin() {
           return lookin;
    }
    
    /**
     * Getter for property fileChooserLookin.     
     */
    public File getFileChooserLookin() {
        if (uploadPath != null) {
           return (new File(uploadPath));
        } else {
           return fileChooserLookin;
        }
    }
    
    /**
     *Getter method for selected.
     */
    public File getSelected() {
        return selected;
    }
    
    /**
     *Setter method for selected.
     */
    public void setSelected(File selected) {
        this.selected = selected;
    }
    
    /**
     *It creates a temp file and uploads it in a specified directory.
     */
    public void writeFile() throws Exception {
        
        if (uploadedFile == null) {
            return;
        }
        String name = uploadedFile.getOriginalName();
        if (name == null || name.length() == 0) {
            name = "tmp.tmp";
        }
        
        int index = name.indexOf(".");
        String suffix = ".tmp";
        if (index != -1) {
            suffix = name.substring(name.indexOf("."));
            if (suffix.length() == 0) {
                suffix = ".tmp";
            }
        }
        String prefix = name;
        if (index != -1) {
            prefix = name.substring(0, name.indexOf("."));
            if (prefix.length() < 3) {
                prefix = "tmp";
            }
            if (prefix.indexOf("\\") != -1) {
                prefix = prefix.replace('\\', '_');
            }
            if (prefix.indexOf(":") != -1) {
                prefix = prefix.replace(':', '_');
            }
        }
        File tempDir = null;
        if (uploadPath != null) {
           tempDir = new File(uploadPath);
        }
        File tmpFile = File.createTempFile(prefix, suffix, tempDir);
        uploadedFile.write(tmpFile);
        
    }
    
    /**
     *Getter method for uploadPath.
     */
    public String getUploadPath() {
        return uploadPath;
    }
    
    /**
     *Setter method for uploadPath.
     */
    public void setUploadPath(String path) {
        uploadPath = path;
    }
    
    /**
     *Action Listener method.
     */
    public void goToPage(ActionEvent e) {
        
        FacesContext context = FacesContext.getCurrentInstance();
        String ClientId = e.getComponent().getClientId(context);
        
        if (ClientId.equals("indexForm:fileChooser")) {
            forwardName = "fileChooser";
            
        } else if (ClientId.equals("indexForm:folderChooser")) {
            forwardName = "folderChooser";
            
        } else if (ClientId.equals("indexForm:fileUploader")) {
            forwardName = "fileUploader";
            
        } else { 
            forwardName = "fileChooserUploader";
        }
    }
    
    /**
     * Action method.
     */
    public String forwardAction() {
        return forwardName;
    }
    
    /**
     * Summary message for Validator exception.
     */
    public String getSummaryMsg() {
        return MessageUtil.getMessage("chooseruploader_summary");
    }
    
    /**
     * Checks for errors on page.
     */
    public boolean isErrorsOnPage() {
        
        FacesMessage.Severity severity =
                FacesContext.getCurrentInstance().getMaximumSeverity();
        if (severity == null) {
            return false;
        }
        if (severity.compareTo(FacesMessage.SEVERITY_ERROR) >= 0) {
            return true;
        }
        return false;
    }
    
    /**
     * Action handler when navigating to the main example index.
     */
    public String showExampleIndex() {
        
        lookin = null;
        selected = null;
        uploadPath = null;
        uploadedFile = null;
        return IndexBackingBean.INDEX_ACTION;
    }
    
    /**
     * Action handler when navigating to the chooser uploader example index.
     */
    public String showUploaderIndex() {
        
        lookin = null;
        selected = null;
        uploadPath = null;
        uploadedFile = null;
        return "showChooserUploader";
    }
}

example/src/com/sun/webui/jsf/example/chooseruploader/FileChooserBackingBean.java
/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright (c) 2007-2018 Oracle and/or its affiliates. All rights reserved.
 *
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common Development
 * and Distribution License("CDDL") (collectively, the "License").  You
 * may not use this file except in compliance with the License.  You can
 * obtain a copy of the License at
 * https://oss.oracle.com/licenses/CDDL+GPL-1.1
 * or LICENSE.txt.  See the License for the specific
 * language governing permissions and limitations under the License.
 *
 * When distributing the software, include this License Header Notice in each
 * file and include the License file at LICENSE.txt.
 *
 * GPL Classpath Exception:
 * Oracle designates this particular file as subject to the "Classpath"
 * exception as provided by Oracle in the GPL Version 2 section of the License
 * file that accompanied this code.
 *
 * Modifications:
 * If applicable, add the following below the License Header, with the fields
 * enclosed by brackets [] replaced by your own identifying information:
 * "Portions Copyright [year] [name of copyright owner]"
 *
 * Contributor(s):
 * If you wish your version of this file to be governed by only the CDDL or
 * only the GPL Version 2, indicate your decision by adding "[Contributor]
 * elects to include this software in this distribution under the [CDDL or GPL
 * Version 2] license."  If you don't indicate a single choice of license, a
 * recipient has the option to distribute your version of this file under
 * either the CDDL, the GPL Version 2 or to extend the choice of license to
 * its licensees as provided above.  However, if you add GPL Version 2 code
 * and therefore, elected the GPL Version 2 license, then the option applies
 * only if the new code is made subject to such option by the copyright
 * holder.
 */

package com.sun.webui.jsf.example.chooseruploader;

import javax.faces.context.FacesContext;
import javax.faces.application.FacesMessage;

import com.sun.webui.jsf.example.index.IndexBackingBean;
import com.sun.webui.jsf.example.common.MessageUtil;

import java.io.*;
import java.util.List;


/**
 * Backing Bean for File Chooser example.
 */
public class FileChooserBackingBean implements Serializable {
    
    // String constant.
    public static final String WINDOWS_OS = "WINDOW";
    
    // Holds value of property lookin.
    private File lookin = null;
    
    // Holds value of property selected.
    private File[] selected;
    
    /** Creates a new instance of FileChooserBackingBean */
    public FileChooserBackingBean() {
        String osName = System.getProperty("os.name").toUpperCase();
        if (osName.startsWith(WINDOWS_OS)) {
            lookin = new File("c:\\\\windows");
        } else {
            lookin = new File("/usr");
        }
    }
    
    /**
     *Getter for property lookin
     *@return Value of property lookin.
     */
    public File getLookin() {
        return lookin;
    }
    
    /**
     *returns absolute path for selected objects.
     */
    private String valueString(Object object) {
        
        if (object instanceof List) {
            List files = (List)object;
            
            Object obj = files.get(0);
            if (obj instanceof File) {
                object = files.toArray(new File[files.size()]);
            } else
                if (obj instanceof String) {
                object = files.toArray(new String[files.size()]);
                } else {
                String value = files.get(0).toString();
                for (int i = 1; i < files.size(); ++i) {
                    value = value + ", " + files.get(i).toString();
                }
                return value;
                }
        }
        
        String value = null;
        if (object instanceof File[]) {
            File[] files = (File[])object;
            value = files[0].getAbsolutePath();
            for (int i = 1; i < files.length; ++i) {
                value = value + ", " + files[i].getAbsolutePath();
            }
        } else
            if (object instanceof File) {
            File file = (File)object;
            value = file.getAbsolutePath();
            } else
                if (object instanceof String[]) {
            String[] files = (String[])object;
            value = files[0];
            for (int i = 1; i < files.length; ++i) {
                value = value + ", " + files[i];
            }
                } else
                    if (object instanceof String) {
            String file = (String)object;
            value = file;
                    }
        return value;
    }
    
    /**
     *Getter method for selected.
     */
    public File[] getSelected() {
        return selected;
    }
    
    /**
     *Setter method for selected.
     */
    public void setSelected(File[] selected) {
        this.selected = selected;
    }
    
    /**
     *Getter method for fileName(s).
     */
    public String getFileName() {
        
        if (selected != null) {
            return valueString(selected);
        } else return null;
    }
 
    /**
     * Summary message for Validator exception.
     */
    public String getSummaryMsg() {           
           return MessageUtil.getMessage("chooseruploader_summary");
    }
    
    /**
     * Checks for errors on page.
     */
    public boolean isErrorsOnPage() {
        
        FacesMessage.Severity severity =
                FacesContext.getCurrentInstance().getMaximumSeverity();
        if (severity == null) {
            return false;
        }
        if (severity.compareTo(FacesMessage.SEVERITY_ERROR) >= 0) {
            return true;
        }
        return false;
    }
       
    /**
     * Action handler when navigating to the main example index.
     */
    public String showExampleIndex() {
        
        selected = null;
        return IndexBackingBean.INDEX_ACTION;
    }
    
    /**
     * Action handler when navigating to the chooser uploader example index.
     */
    public String showUploaderIndex() {
        
        selected = null;
        return "showChooserUploader";
    }
}

example/web/chooseruploader/folderChooserPopup.jspx
<?xml version="1.0" encoding="UTF-8"?>
<!--

    DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.

    Copyright (c) 2007-2018 Oracle and/or its affiliates. All rights reserved.

    The contents of this file are subject to the terms of either the GNU
    General Public License Version 2 only ("GPL") or the Common Development
    and Distribution License("CDDL") (collectively, the "License").  You
    may not use this file except in compliance with the License.  You can
    obtain a copy of the License at
    https://oss.oracle.com/licenses/CDDL+GPL-1.1
    or LICENSE.txt.  See the License for the specific
    language governing permissions and limitations under the License.

    When distributing the software, include this License Header Notice in each
    file and include the License file at LICENSE.txt.

    GPL Classpath Exception:
    Oracle designates this particular file as subject to the "Classpath"
    exception as provided by Oracle in the GPL Version 2 section of the License
    file that accompanied this code.

    Modifications:
    If applicable, add the following below the License Header, with the fields
    enclosed by brackets [] replaced by your own identifying information:
    "Portions Copyright [year] [name of copyright owner]"

    Contributor(s):
    If you wish your version of this file to be governed by only the CDDL or
    only the GPL Version 2, indicate your decision by adding "[Contributor]
    elects to include this software in this distribution under the [CDDL or GPL
    Version 2] license."  If you don't indicate a single choice of license, a
    recipient has the option to distribute your version of this file under
    either the CDDL, the GPL Version 2 or to extend the choice of license to
    its licensees as provided above.  However, if you add GPL Version 2 code
    and therefore, elected the GPL Version 2 license, then the option applies
    only if the new code is made subject to such option by the copyright
    holder.

-->

<jsp:root version="2.0" xmlns:f="http://java.sun.com/jsf/core" xmlns:h="http://java.sun.com/jsf/html" xmlns:jsp="http://java.sun.com/JSP/Page" xmlns:webuijsf="http://www.sun.com/webui/webuijsf">
    <jsp:directive.page contentType="text/html"/>
    <f:view>
        <webuijsf:page >
            <webuijsf:html>
                <f:loadBundle basename="com.sun.webui.jsf.example.resources.Resources" var="msgs" />
                <webuijsf:head id="folderChooserHead" title="#{msgs.folderChooser_title}">
                <script>                  
                 
                   /**
                     * This js function populates the directory field of parent screen.  
                     * 
                     */
                    function fnPopulateDir(){
             
                    var dirPath=document.getElementById("folderFormPopup:folderContent:folderChooser:folderChooser_lookinField").value;
                    var selfield = document.getElementById("folderFormPopup:folderContent:folderChooser:folderChooser_selectedField").value;
                        if (selfield.length > 0) {
                            if (((dirPath.lastIndexOf('\\')) == (dirPath.length-1))){
                                     dirPath = dirPath + selfield;   

                            } else if ((dirPath.indexOf('\\')) >= 0 ) {
                                     dirPath = dirPath + "\\" + selfield;  
                            }
                            if ( (dirPath.lastIndexOf('/')) == (dirPath.length-1)){
                                     dirPath = dirPath + selfield;            
                            } else if ((dirPath.lastIndexOf('/')) >= 0) {
                                     dirPath = dirPath + "/" + selfield;
                            }
                        }
                        window.opener.document.getElementById("uploaderFormPopup:dirPath_field").value = dirPath;
                                window.close();    
                    }
               
                 </script>
                </webuijsf:head>
                <webuijsf:body>

                    <webuijsf:form id="folderFormPopup">

                   <!-- Masthead -->
                   <webuijsf:masthead id="Masthead" productImageURL="/images/example_primary_masthead.png"
                     productImageDescription="#{msgs.mastheadAltText}" 
                     userInfo="test_user"
                     serverInfo="test_server" secondary="true"/>     

                     <br />
                     <!-- Alert for validator exception. -->
                     <webuijsf:alert id="popupFolderChooserAlert" rendered="#{ChooserUploaderBean.errorsOnPage}" type="error" 
                                     summary="#{ChooserUploaderBean.summaryMsg}">                              
                          <webuijsf:message for="folderChooser" showDetail="true"/>
                     </webuijsf:alert>
                                                
                     <!-- Page Title -->
                     <webuijsf:contentPageTitle title="#{msgs.folderChooser_title}" id="folderContent">
                       <webuijsf:markup tag="div" styleClass="#{themeStyles.CONTENT_MARGIN}">
                            
                       <!-- Folder Chooser -->
                       <f:verbatim><![CDATA[<table><tr><td>]]></f:verbatim>
                         <webuijsf:fileChooser id="folderChooser"
			                 lookin="#{ChooserUploaderBean.lookin}"
                                         selected="#{ChooserUploaderBean.selected}"
                                         sortField="size" descending="true" 
		                         multiple="false" folderChooser="true"/>
                       <f:verbatim><![CDATA[</td></tr>]]></f:verbatim>
                                                 
                       <!--  Folder Chooser button -->
                       <f:verbatim><![CDATA[<tr><td>]]></f:verbatim>
                               <webuijsf:button id="select_folder"
                                        text="#{msgs.folderChooser_buttonCaption}" 
                                     onClick="fnPopulateDir()"
                                     toolTip="#{msgs.folderChooser_buttonTooltip}"/>
                       <f:verbatim><![CDATA[</td></tr></table>]]></f:verbatim>
                       </webuijsf:markup>
                     </webuijsf:contentPageTitle>
                     <script>
                         document.getElementById("folderForm:folderContent:folderChooser").setChooseButton("folderFormPopup:folderContent:select_folder");
                     </script>
                    </webuijsf:form>
                </webuijsf:body> 
            </webuijsf:html>  
        </webuijsf:page>
    </f:view>
</jsp:root>